#include <iostream>
#include "CEpollServer.h"
#include "CUdpServer.h"
#include "CApp.h"
#include <pthread.h>
#include <stdlib.h>

using namespace std;

#define TCP_SERVER_PORT 8002

void *udpServer_thread(void *param){
	CApp* app=(CApp *)param;
	CUdpServer* user=new CUdpServer(TCP_SERVER_PORT+1);
	user->Start(false);
	delete user;
}
void *tcpServer_thread(void *param){
	CApp* app=(CApp *)param;
	CEpollServer* epoll = new CEpollServer(TCP_SERVER_PORT);
	app->conn=epoll->conn;
	app->conn->user_data=app;
	epoll->Start();
	delete epoll;
}

int main(int argc, char *argv[]){
	pthread_t t_thread_udp,t_thread_tcp;

	wlog_info("wecho server start:tcp port=%d,udp port=%d", TCP_SERVER_PORT, TCP_SERVER_PORT+1);
	//新建应用处理
	CApp* app=new CApp();

	//新开线程处理UDP服务器
	pthread_create(&t_thread_udp,NULL,udpServer_thread, app);
	//新开线程处理TCP服务器
	pthread_create(&t_thread_tcp,NULL,tcpServer_thread, app);

	app->loop();
	pthread_join(t_thread_udp, NULL);
	pthread_join(t_thread_tcp, NULL);

	delete app;
	return 0;
}
