#include "CConnection.h"
#include <sys/epoll.h>
#include "CApp.h"
#define TCP_CONNECTION_IDLE_TIME_S 60

CConnection::CConnection()
{
    this->tmpGroupId=0;
}

CConnection::~CConnection()
{
}

void CConnection::push_item(int fd){//不可能有相同的链路的
    CONN_DEF *item;
    bool need_push=false;

    for(std::list<CONN_DEF *>::iterator it=this->list.begin();it!=this->list.end();it++){
        item=(CONN_DEF *)*it;
        if(item->valid==true) continue;
        goto SET_AND_PUSH;
    }
    item=new CONN_DEF;
    need_push=true;
    SET_AND_PUSH:
    item->tcp_fd=fd;
    item->time_out=0;
    item->valid=true;
    if(need_push==true)
        this->list.push_back(item);
}

void CConnection::setEpollFd(int fd){
    this->epollfd=fd;
}
void CConnection::run(){
    CApp *app=(CApp *)this->user_data;
    CONN_DEF *item,*itemA;

    for(std::list<CONN_DEF *>::iterator it=this->list.begin();it!=this->list.end();it++){
        item=(CONN_DEF *)*it;
        if(item->valid==false) continue;
        if(++item->time_out>=TCP_CONNECTION_IDLE_TIME_S){
            wlog_warn("conn idle:%d", item->tcp_fd);
            disconnect(item,this->epollfd);
        }
    }
}

int CConnection::TSendData(int fd, unsigned char *data , int len){
    return write(fd, data, len);
}
void CConnection::disconnect(CONN_DEF *conn,int epollfd){
    conn->valid=false;
    close(conn->tcp_fd);
    //从epoll中删除客户端描述符
    epoll_ctl(epollfd, EPOLL_CTL_DEL, conn->tcp_fd, NULL);
}

CONN_DEF *CConnection::findConnBySock(int fd){
    CONN_DEF *item;

    for(std::list<CONN_DEF *>::iterator it=this->list.begin();it!=this->list.end();it++){
        item=(CONN_DEF *)*it;
        if(item->valid==false) continue;
        if(item->tcp_fd!=fd) continue;
        return item;
    }
    return NULL;
}

int CConnection::getEpollFd(){
    return this->epollfd;
}