#include "CUdpServer.h"

CUdpServer::CUdpServer(unsigned short port)
    :CBaseSocket(port)
{
    this->address = new CHostAddress(port);
}
 
CUdpServer::~CUdpServer()
{
}
 
void CUdpServer::Run()
{
    int res = 0;
 
    res = bind(this->socketFd, this->address->getAddr(), this->address->getLength());
    if (res == -1)
    {
        wlog_error("udp bind error");
        return;
    }

    wlog_info("UDP_Server start success:%d",this->socketFd);

    char buf[128];
    char ipbuf[16];
    struct sockaddr_in cli_addr;
    int len=sizeof(cli_addr);
    int num;
    for(;;){
        num=recvfrom(this->socketFd, buf, sizeof(buf), 0, (struct sockaddr *)&cli_addr, (socklen_t *)&len);
 //       wlog_info("client<%s:%d>%s",inet_ntop(AF_INET, &cli_addr.sin_addr.s_addr, ipbuf, sizeof(ipbuf)),
 //                                       ntohs(cli_addr.sin_port),
 //                                       buf);
        // 发送数据,+是因为字符串的结束符也要发过去 
        sendto(this->socketFd, buf, num, 0, (struct sockaddr *)&cli_addr, sizeof(cli_addr));
    }
}

void CUdpServer::Stop()
{
    if (this->socketFd != 0)
    {
        close(this->socketFd);
        this->socketFd = 0;
    }
}
 
CHostAddress* CUdpServer::getAddress()
{
    return this->address;
}
 
void CUdpServer::setAddress(CHostAddress* address)
{
    this->address = address;
}
